import { TFInput, TFOutput } from './TFBase'

/**
 * 根据保函协议编号查询协议信息
 * 根据保函协议编号查询保函登记簿的详细信息
 */
export class QueryGuaranteeInfomationByNum extends TFOutput {
    // #region Output
    /**
     * 质押物类别 0220
     */
    public ZYWLB: string = ''

    /**
     * 申请人户名 0250
     */
    public SQRHM: string = ''

    /**
     * 受益人户名 0260
     */
    public SYRHM: string = ''

    /**
     * 申请人客户号 0280
     */
    public SQRKHH: string = ''

    /**
     * 受益人客户号 0290
     */
    public SYRKHH: string = ''

    /**
     * 申请人账号 0300
     */
    public SQRZH: string = ''

    /**
     * 受益人账号 0310
     */
    public SYRZH: string = ''

    /**
     * 保证金账号 0320
     */
    public BZJZH: string = ''

    /**
     * 垫款账号 0330
     */
    public DKZH: string = ''

    /**
     * 质押物号码 0370
     */
    public ZYWHM: string = ''

    /**
     * 合同总金额 0390
     */
    public HTZJE: string = ''

    /**
     * 保函金额 0400
     */
    public BHJE: string = ''

    /**
     * 保证金金额 0410
     */
    public BZJJE: string = ''

    /**
     * 赔偿金额 0420
     */
    public PCJE: string = ''

    /**
     * 保证金比例 0430
     */
    public BZJBL: string = ''

    /**
     * 交易日期 0440
     */
    public JYRQ: string = ''

    /**
     * 保函到期日期 0450
     */
    public BHDQRQ: string = ''

    /**
     * 开具保函日期 0460
     */
    public KJBHRQ: string = ''

    /**
     * 保函有效期限 0470
     */
    public BHYXQX: string = ''

    /**
     * 申请人电话 0580
     */
    public SQRDH: string = ''

    /**
     * 受益人电话 0590
     */
    public SYRDH: string = ''

    /**
     * 是否有记录 0660
     * 0无1有
     */
    public SFYJL: string = ''

    /**
     * 协议状态 0670
     * A-存保证金 0、审核1核销X信贷录入
     */
    public XYZT: string = ''

    /**
     * 保函类型 0700
     * 0预付款退款保函 1付款保函 2关税保付保函 3工程投标保函 4工程承包履约保函 5工程维修保函 6加工承揽商贸履约保函 7质量保函
     */
    public BHLX: string = ''

    /**
     * 申请人地址 0810
     */
    public SQRDZ: string = ''

    /**
     * 受益人地址 0820
     */
    public SYRDZ: string = ''

    /**
     * 逾期利率 0840
     */
    public YQLL: string = ''

    /**
     * 担保费比例 0850
     */
    public DBFLL: string = ''

    /**
     * 垫款金额 1001
     */
    public DKJE: string = ''

    /**
     * 质押总额 1002
     */
    public ZYZE: string = ''

    /**
     * 交易机构 0910
     */
    public JYJG: string = ''

    /**
     * 项目名称 0830
     */
    public XMMC: string = ''

    /**
     * 担保合同号 0860
     */
    public DBHTH: string = ''

    /**
     * 手续费比例 1005
     */
    public SXFBL: string = ''

    /**
     * 保证金利率 0970
     */
    public BZJLL: string = ''
    // #endregion

    // #region Input
    /**
     * 参数清单
     */
    public static Input = class extends TFInput {
        /**
         * 保函协议编号 0630
         */
        public BHXYBH: string = ''

        /**                 
         * 定义业务逻辑              
         * @returns 操作结果
         */
        public override Raise(): TFOutput {
            // 拉取数据                                  
            const output = new QueryGuaranteeInfomationByNum()
            this.PageData.TradeAPIs.InitFd(this.MessageData)
            this.PageData.TradeAPIs.CommSend(this.MessageData)
            this.MessageData.Fd126_5 = this.MainCode
            this.MessageData.Fd16 = "K004"
            this.MessageData.Fd63 = this.BHXYBH

            this.PageData.TradeAPIs.CallServer(this.MessageData)
            if (this.MessageData.Fd12 != "0000") {
                output.IsFailed = true
                output.FailureCause = this.PageData.TradeAPIs.GetError(this.MessageData)
            }
            output.ZYWLB = this.DelSpace(this.MessageData.Fd22)
            output.SQRHM = this.DelSpace(this.MessageData.Fd25)
            output.SYRHM = this.DelSpace(this.MessageData.Fd26)
            output.SQRKHH = this.DelSpace(this.MessageData.Fd28)
            output.SYRKHH = this.DelSpace(this.MessageData.Fd29)
            output.SQRZH = this.DelSpace(this.MessageData.Fd30)
            output.SYRZH = this.DelSpace(this.MessageData.Fd31)
            output.BZJZH = this.DelSpace(this.MessageData.Fd32)
            output.DKZH = this.DelSpace(this.MessageData.Fd33)
            output.ZYWHM = this.DelSpace(this.MessageData.Fd37)
            output.HTZJE = this.DelSpace(this.MessageData.Fd39)
            output.BHJE = this.DelSpace(this.MessageData.Fd40)
            output.BZJJE = this.DelSpace(this.MessageData.Fd41)
            output.PCJE = this.DelSpace(this.MessageData.Fd42)
            output.BZJBL = this.DelSpace(this.MessageData.Fd43)
            output.JYRQ = this.DelSpace(this.MessageData.Fd44)
            output.BHDQRQ = this.DelSpace(this.MessageData.Fd45)
            output.KJBHRQ = this.DelSpace(this.MessageData.Fd46)
            output.BHYXQX = this.DelSpace(this.MessageData.Fd47)
            output.SQRDH = this.DelSpace(this.MessageData.Fd58)
            output.SYRDH = this.DelSpace(this.MessageData.Fd59)
            output.SFYJL = this.DelSpace(this.MessageData.Fd66)
            output.XYZT = this.DelSpace(this.MessageData.Fd67)
            output.BHLX = this.DelSpace(this.MessageData.Fd70)
            output.SQRDZ = this.DelSpace(this.MessageData.Fd81)
            output.SYRDZ = this.DelSpace(this.MessageData.Fd82)
            output.YQLL = this.DelSpace(this.MessageData.Fd84)
            output.DBFLL = this.DelSpace(this.MessageData.Fd85)
            output.DKJE = this.DelSpace(this.MessageData.Fd100_1)
            output.ZYZE = this.DelSpace(this.MessageData.Fd100_2)
            output.JYJG = this.DelSpace(this.MessageData.Fd91)
            output.XMMC = this.DelSpace(this.MessageData.Fd83)
            output.DBHTH = this.DelSpace(this.MessageData.Fd86)
            output.SXFBL = this.DelSpace(this.MessageData.Fd100_5)
            output.BZJLL = this.DelSpace(this.MessageData.Fd97)

            return output
        }
    }
    // #endregion
}

/**
 * 创建保函协议信息查询功能的Vue 3组合式API封装
 */
export function useQueryGuaranteeInfomationByNum() {
    /**
     * 根据保函协议编号查询协议信息
     * @param params 查询参数
     * @param page 页面对象
     * @returns 保函协议信息查询结果
     */
    const queryGuaranteeInfomationByNum = (
        params: {
            BHXYBH: string  // 保函协议编号
        },
        page: any
    ): QueryGuaranteeInfomationByNum => {
        const input = new QueryGuaranteeInfomationByNum.Input()

        // 设置查询参数
        Object.assign(input, params)

        // 执行查询
        return input.DoAction<QueryGuaranteeInfomationByNum>(page)
    }

    return {
        queryGuaranteeInfomationByNum
    }
}
