import { TFInput, TFOutput } from './TFBase'

/**
 * 查询贷款账号信息
 * 通过贷款账号查询账户信息
 */
export class QueryLoanAccount extends TFOutput {
    // #region Output Properties
    /** 开户机构 0020 */
    public KHJG: string = ''
    /** 币种 0210 */
    public BZ: string = ''
    /** 户名 0250 */
    public HM: string = ''
    /** 借据号 0310 */
    public JJH: string = ''
    /** 放款账号 0320 */
    public FKZH: string = ''
    /** 还款账号1 0330 */
    public HKZH1: string = ''
    /** 贷款账户序号 0340 */
    public ZHXH: string = ''
    /** 还款账号2 0370 */
    public HKZH2: string = ''
    /** 还款账号3 0380 */
    public HKZH3: string = ''
    /** 贷款现余额 0390 */
    public DKXYE: string = ''
    /** 计划放款额 0400 */
    public JHFKE: string = ''
    /** 放款余额 0410 */
    public FKYE: string = ''
    /** 表内欠息 0420 */
    public BNQX: string = ''
    /** 表外欠息 0430 */
    public BWQX: string = ''
    /** 还款日 0440 */
    public HKR: string = ''
    /** 担保方式 0660 (3抵押 4信用 5保证 7委托 B质押) */
    public DBFS: string = ''
    /** 贷款类型 0670 (1普通贷款 2按揭贷款 5承兑垫款 7委托贷款 9贴现 A授信贷款 B卡内融资) */
    public DKLX: string = ''
    /** 账户状态 0680 */
    public ZHZT: string = ''
    /** 活期账户状态 0690 */
    public HQZHZT: string = ''
    /** 活期账户冻结状态 0700 */
    public HQZHDJZT: string = ''
    /** 活期账户止付状态 0710 */
    public HQZHZFZT: string = ''
    /** 展期标志 0720 */
    public ZQBZ: string = ''
    /** 合同利率 0840 */
    public HTLL: string = ''
    /** 合同利率浮动比 0850 */
    public HTLLFDB: string = ''
    /** 开户机构号 0910 */
    public KHJGH: string = ''
    /** 委托关联标志 0930 */
    public WTGLBZ: string = ''
    /** 利率类型 0980 (Y-年利率，M-月利率) */
    public LLLX: string = ''
    /** 复利欠息 1001 */
    public FLQX: string = ''
    /** 还息账号1 1011 */
    public HXZH1: string = ''
    /** 本期本金(按揭) 1013 */
    public BQBJ: string = ''
    /** 摘要 1016 */
    public ZY: string = ''
    /** 还息账号2 1021 */
    public HXZH2: string = ''
    /** 凭证种类 1023 */
    public PZZL: string = ''
    /** 本期利息(按揭) 102F */
    public BQLX: string = ''
    /** 贷款放款产品名称 102V */
    public CPMC: string = ''
    /** 还息账号3 102W */
    public HXZH3: string = ''
    /** 开户日期 1053 */
    public KHRQ: string = ''
    /** 到期日期 1054 */
    public DQRQ: string = ''
    /** 客户级别 105H (0普通级 1银级 2金级 3白金级 4钻石级) */
    public KHJB: string = ''
    /** 展期利率 105I */
    public ZQLL: string = ''
    /** 展期到期日 105J */
    public ZQDQR: string = ''
    /** 柜面还款顺序 107I (B先还本金 L先还利息 A不限制) */
    public GMHKSX: string = ''
    /** 本金核销金额 1085 */
    public BJHXJE: string = ''
    /** 利息核销金额 1086 */
    public LXHXJE: string = ''
    /** 未结本金利息 1088 */
    public WJBJLX: string = ''
    /** 未结复利利息 1089 */
    public WJFLLX: string = ''
    /** 累计放款金额 1244 */
    public LJFKJE: string = ''
    /** 基金户可用余额 1246 */
    public JJHKYYE: string = ''
    /** 贷款状态 1024 */
    public DKZT: string = ''
    /** 客户号 0280 */
    public KHH: string = ''
    /** 标志位 0740 */
    public BZW: string = ''
    /** 授信到期日 0460 */
    public SXDQR: string = ''
    /** 最早还本日期 0470 */
    public ZZHBRQ: string = ''
    /** 合同号 1197 */
    public HTH: string = ''
    /** 贷款产品名称 101F */
    public DKCPMC: string = ''
    /** 还款账号1序号 0350 */
    public HKZHXH: string = ''
    /** 正常积数值 0560 */
    public ZCJSZ: string = ''
    /** 逾期积数值 0570 */
    public YQJSZ: string = ''
    /** 默认还款顺序 108J */
    public MRHKSX: string = ''
    /** 账号 0300 */
    public ZH: string = ''
    /** 证件类型 1164 */
    public ZJLX: string = ''
    /** 证件号码 1165 */
    public ZJHM: string = ''
    /** 违约利率 0970 */
    public WYLL: string = ''
    /** 委托编号 102A */
    public WTBH: string = ''
    /** 逾期利率 1123 */
    public YQLL: string = ''
    /** 浮比浮点等 0810 */
    public FBFDD: string = ''
    /** 欠款本金(按揭) 1002 */
    public QKBJ: string = ''
    /** 欠款利息(按揭) 1003 */
    public QKLX: string = ''
    /** 欠款罚息(按揭) 1004 */
    public QKFX: string = ''
    /** 第一还本补贴比例或金额 */
    public HBBTZ1: string = ''
    /** 第二还本补贴比例或金额 */
    public HBBTZ2: string = ''
    /** 第三还本补贴比例或金额 */
    public HBBTZ3: string = ''
    /** 第一还息补贴比例或金额 */
    public HXBTZ1: string = ''
    /** 第二还息补贴比例或金额 */
    public HXBTZ2: string = ''
    /** 第三还息补贴比例或金额 */
    public HXBTZ3: string = ''
    /** 文件数据 */
    public FILEDATA: string = ''
    // #endregion

    // #region Input
    /**
     * 查询贷款账号的输入参数
     */
    public static Input = class extends TFInput {
        /** 贷款账号 0300 */
        public DKZH: string = ''
        /** 账户序号 0340 */
        public ZHXH: string = ''
        /** 委托编号 0620 */
        public WTBH: string = ''
        /** 借据号 0630 */
        public JJH: string = ''

        /**
         * 执行贷款账号查询
         * @returns 查询结果
         */
        public override Raise(): TFOutput {
            const output = new QueryLoanAccount()

            // 初始化交易数据
            this.PageData.TradeAPIs.InitFd(this.MessageData)
            this.PageData.TradeAPIs.CommSend(this.MessageData)

            // 设置查询参数
            this.MessageData.Fd126_5 = this.MainCode
            this.MessageData.Fd16 = "K015"
            this.MessageData.Fd30 = this.DKZH
            this.MessageData.Fd34 = this.ZHXH
            this.MessageData.Fd62 = this.WTBH
            this.MessageData.Fd63 = this.JJH

            // 调用服务
            this.PageData.TradeAPIs.CallServer(this.MessageData)

            // 错误处理
            if (this.MessageData.Fd12 != "0000") {
                output.IsFailed = true
                output.FailureCause = this.PageData.TradeAPIs.GetError(this.MessageData)
                return output
            }

            // 映射输出字段
            output.KHJG = this.DelSpace(this.MessageData.Fd2)
            output.BZ = this.MessageData.Fd21
            output.HM = this.MessageData.Fd25
            output.JJH = this.MessageData.Fd31
            output.FKZH = this.MessageData.Fd32
            output.HKZH1 = this.MessageData.Fd33
            output.ZHXH = this.MessageData.Fd34
            output.HKZH2 = this.MessageData.Fd37
            output.HKZH3 = this.MessageData.Fd38
            output.DKXYE = this.MessageData.Fd39
            output.JHFKE = this.MessageData.Fd40
            output.FKYE = this.MessageData.Fd41
            output.BNQX = this.MessageData.Fd42
            output.BWQX = this.MessageData.Fd43
            output.HKR = this.MessageData.Fd44
            output.DBFS = this.MessageData.Fd66
            output.DKLX = this.MessageData.Fd67
            output.ZHZT = this.MessageData.Fd68
            output.HQZHZT = this.MessageData.Fd69
            output.HQZHDJZT = this.MessageData.Fd70
            output.HQZHZFZT = this.MessageData.Fd71
            output.ZQBZ = this.MessageData.Fd72
            output.HTLL = this.MessageData.Fd84
            output.HTLLFDB = this.MessageData.Fd85
            output.KHJGH = this.MessageData.Fd91
            output.WTGLBZ = this.MessageData.Fd93
            output.LLLX = this.MessageData.Fd98
            output.FLQX = this.MessageData.Fd100_1
            output.HXZH1 = this.MessageData.Fd101_1
            output.BQBJ = this.MessageData.Fd101_3
            output.ZY = this.MessageData.Fd101_6
            output.HXZH2 = this.MessageData.Fd102_1
            output.PZZL = this.MessageData.Fd102_3
            output.BQLX = this.MessageData.Fd102_F
            output.CPMC = this.MessageData.Fd102_V
            output.HXZH3 = this.MessageData.Fd102_W
            output.KHRQ = this.MessageData.Fd105_3
            output.DQRQ = this.MessageData.Fd105_4
            output.KHJB = this.MessageData.Fd105_H
            output.ZQLL = this.MessageData.Fd105_I
            output.ZQDQR = this.MessageData.Fd105_J
            output.HBBTZ1 = this.MessageData.Fd107_4
            output.HBBTZ2 = this.MessageData.Fd107_7
            output.HBBTZ3 = this.MessageData.Fd107_E
            output.GMHKSX = this.MessageData.Fd107_I
            output.HXBTZ1 = this.MessageData.Fd108_4
            output.BJHXJE = this.MessageData.Fd108_5
            output.LXHXJE = this.MessageData.Fd108_6
            output.HXBTZ2 = this.MessageData.Fd108_7
            output.WJBJLX = this.MessageData.Fd108_8
            output.WJFLLX = this.MessageData.Fd108_9
            output.HXBTZ3 = this.MessageData.Fd108_E
            output.LJFKJE = this.MessageData.Fd124_4
            output.JJHKYYE = this.MessageData.Fd124_6
            output.DKZT = this.MessageData.Fd102_4
            output.KHH = this.MessageData.Fd28
            output.BZW = this.MessageData.Fd74
            output.SXDQR = this.MessageData.Fd46
            output.ZZHBRQ = this.MessageData.Fd47
            output.HTH = this.MessageData.Fd119_7
            output.DKCPMC = this.MessageData.Fd101_F
            output.HKZHXH = this.MessageData.Fd35
            output.ZCJSZ = this.MessageData.Fd56
            output.YQJSZ = this.MessageData.Fd57
            output.MRHKSX = this.MessageData.Fd108_J
            output.ZH = this.MessageData.Fd30
            output.ZJLX = this.MessageData.Fd116_4
            output.ZJHM = this.MessageData.Fd116_5
            output.WYLL = this.MessageData.Fd97
            output.WTBH = this.MessageData.Fd102_A
            output.YQLL = this.MessageData.Fd112_3
            output.FBFDD = this.MessageData.Fd81
            output.QKBJ = this.MessageData.Fd100_2
            output.QKLX = this.MessageData.Fd100_3
            output.QKFX = this.MessageData.Fd100_4
            output.FILEDATA = this.MessageData.FileData

            return output
        }
    }
    // #endregion
}

/**
 * 创建贷款账号查询的Vue 3组合式API封装
 */
export function useQueryLoanAccount() {
    /**
     * 执行贷款账号查询
     * @param params 查询参数
     * @param page 页面对象
     * @returns 查询结果
     */
    const executeLoanAccountQuery = (
        params: {
            DKZH?: string  // 贷款账号
            ZHXH?: string  // 账户序号
            WTBH?: string  // 委托编号
            JJH?: string   // 借据号
        },
        page: any
    ): QueryLoanAccount => {
        const input = new QueryLoanAccount.Input()

        // 设置查询参数
        Object.assign(input, params)

        // 执行查询
        return input.DoAction<QueryLoanAccount>(page)
    }

    return {
        executeLoanAccountQuery
    }
}
