import { reactive, ref } from 'vue'
import { AuthConditionElement } from './AuthConditionElement'
import Message from '@/views/front/develop/Communication/Message'
import { PageBase } from '../../ContractBase/PageBase'
import { TradeBusData } from "@/views/front/develop/Library.Ext/TradeExtension/TradeInfo/TradeBusData"
import { TradeInfoData } from "@/views/front/develop/Library.Ext/TradeExtension/TradeInfo/TradeInfoData"
import { AuthDataHelper } from './AuthDataHelper'
//  import LoginUserInfo from "@/views/front/platfrom/common/RunningParameters/LoginUserInfo";
// import { TradeHandle } from '../../Library/Ext/TradeExtension/TradeHandle'
// import { UserManagerHandle } from '../../Library/Ext/Function/UserManagerHandle'
// import { AuthHandle } from '../../ServiceProxy/Ext/WebAPI/Auth/AuthHandle'
// import { ElementInfoResult } from '../../ServiceProxy/Ext/WebAPI/Auth/Entity/ElementInfoResult'
// import { QueryTellerStatusBatch } from '../../ServiceProxy/Ext/ServiceHelper/QueryTellerStatusBatch'
// import { LoginAuthentication } from './LoginAuthentication'

/**
 * 授权对象，在交易中使用此对象来申请授权
 */
export class AuthManager {
    private static _instance: AuthManager
    private _systemSerialNumber: string = ''
    AsksuperResultMessage: (result: any, dataBus: any) => void

    public static get Instance(): AuthManager {
        if (!AuthManager._instance) {
            AuthManager._instance = new AuthManager()
        }
        return AuthManager._instance
    }

    get SystemSerialNumber(): string {
        return this._systemSerialNumber
    }
    set SystemSerialNumber(value: string) {
        this._systemSerialNumber = value
    }

    // 授权有结果时触发的事件
    public onAsksuperResult: ((result: AsksuperResultType, busData: TradeBusData) => void) | null = null

    /**
     * 检查授权
     */
    public async DoAuth(
        target: PageBase,
        element: AuthConditionElement,
        msg: Message,
        pagedata: PageData[],
        funcnum: string,
        accountno: string,
        amount: string,
        count: string,
        custname: string,
        des: string,
        branch: string
    ): Promise<boolean> {
        //hulei_todo 授权

        return true
    }

    /**
     * 本地授权处理
     */
    private async LocalAuth(
        target: PageBase,
        pagedata: PageData[],
        accountno: string,
        amount: number,
        custname: string,
        des: string,
        tradedata: TradeBusData
    ): Promise<boolean> {
        // ... 本地授权业务逻辑实现 ...
        return true
    }

    /**
     * 远程授权处理
     */
    private async RemoteAuth(
        target: PageBase,
        pagedata: PageData[],
        accountno: string,
        amount: number,
        custname: string,
        des: string
    ): Promise<boolean> {
        // ... 远程授权业务逻辑实现 ...
        return true
    }

    // ... 其他方法实现 ...
}

// Vue组合式API封装
export const useAuthManager = () => {
    const authManager = reactive(AuthManager.Instance)
    return {
        authManager
    }
}

// 类型定义
interface PageData {
    index: number
    datas: Uint8Array
}

type ImageSource = any
type AsksuperResultType = 'Success' | 'Failed' | 'Cancel'
