import { TradePowerManager } from "../TradeMenu/TradePowerManager";
import { TradeBusData } from "../TradePrint/TradeInfo/TradeBusData";


// 模拟 DependencyObject 类 hulei-s window依赖属性类需要模拟实现
// class DependencyObject {
//     private properties: { [key: string]: any } = {};

//     getValue(key: string): any {
//         return this.properties[key];
//     }

//     setValue(key: string, value: any): void {
//         this.properties[key] = value;
//     }
// }

// 模拟 UIPropertyMetadata 类 hulei-s windows自带框架
class UIPropertyMetadata {
    constructor(public defaultValue: any) { }
}
// // 定义 TradeInfoData 类  附加属性hulei
class TradeInfoData {
    static readonly TradeInfoProperty = {
        name: 'TradeInfo',
        type: TradeInfoData,
        ownerType: TradeInfoData,
        metadata: new UIPropertyMetadata(null)
    };
    TradeScreens: Map<string, ImageBitmap[]>;

    static GetTradeInfo(): TradeInfoData {
        //obj.getValue(this.TradeInfoProperty.name) as hulei_s 处理
        return new TradeInfoData;
    }

    static SetTradeInfo(obj: DependencyObject, value: TradeInfoData): void {
        // obj.setValue(this.TradeInfoProperty.name, value);
    }

    SerialNumber: string;
    SystemSerialNumber: string;
    PrintNum: string;
    TradeCode: string;
    TradeName: string;
    TradeBus: TradeBusData;

    constructor() {
        this.SerialNumber = '';
        this.SystemSerialNumber = '';
        this.PrintNum = '';
        this.TradeCode = '';
        this.TradeName = '';
        this.TradeBus = new TradeBusData();
    }

    CheckTradePower(powerCode: string): boolean {
        const list = TradePowerManager.Instance.GetTradePowerByCode(this.TradeCode);
        if (list.length === 0) {
            return false;
        }
        return list.some((item) => item.RuleNo === powerCode);
    }
}

export { TradeInfoData };
