// 重载签名（声明不同的参数和返回类型）
function greet(name: string): string;        // 接收字符串
function greet(age: number): string;        // 接收数字
function greet(isMorning: boolean): string; // 接收布尔值

// 实现签名（必须兼容所有重载）
function greet(value: string | number | boolean): string {
    if (typeof value === "string") {
        return `Hello, ${value}!`;
    } else if (typeof value === "number") {
        return `You are ${value} years old!`;
    } else {
        return `Good ${value ? "morning" : "day"}!`;
    }
}

// 调用测试
console.log(greet("Alice"));  // "Hello, Alice!"
console.log(greet(25));       // "You are 25 years old!"
console.log(greet(true));     // "Good morning!"
